﻿using Unit4.CollectionsLib;

/// <summary>
/// פתרון לשאלה 2 פרק 11
/// ====================
/// מחלקה המגדירה ספר טלפונים המיוצגת בעזרת מפה, הממפה שמות אנשי קשר למספר הטלפון שלהם
/// </summary>
/// 
/// <author> צוות מדעי המחשב, המרכז להוראת המדעים, האוניברסיטה העברית, ירושלים </author>
/// 
/// <version> 28.11.2007 </version>

public class PhoneBook
{
	private Map<string> pbook;
	
	public PhoneBook()
	{
		this.pbook = new Map<string>();
	}
	
	public string GetPhone(string name)
	{
        if(this.pbook.ContainsKey(name))
		    return this.pbook.GetValue(name);
        return null;
	}
	
	public void AddContact(string name, string phone)
	{	
		this.pbook.Insert(name,phone);
	}
	
	public void DelContact(string name)
	{
        if (this.pbook.ContainsKey(name))
		    this.pbook.Remove(name);
	}	
	
	public string[] GetAllContactsNames()
	{
		return this.pbook.GetAllKeys();
	}
	
	public override string ToString()
	{
		string str = "";
		string[] names = this.pbook.GetAllKeys();

		for (int i = 0; i < names.Length; i++)
			str = str + names[i] + "\t" + GetPhone(names[i]) + "\n";
		
		return str;
	}
}