﻿using Unit4.CollectionsLib;

/// <summary>
/// פתרון למשימה מספר 1 מפרק 11 מפה - ייצוג המפה בעזרת רשימה של זוגות השומרת את המפתחות בצורה ממוינת
/// ================================================================================================
/// </summary>
/// <author> צוות מדעי המחשב, המרכז להוראת המדעים, האוניברסיטה העברית, ירושלים </author>
/// <version> 28.11.2007 </version>
/// <typeparam name="V">טיפוס הערכים הקשורים למפתחות</typeparam>

public class Map<V>
{	
	private List<Pair<string,V>> lst; 
	private int numOfKeys;
	
    
	public Map()
	{
		this.lst = new List<Pair<string,V>>();
		this.numOfKeys = 0;
	}

  
    public bool ContainsKey(string key)
    {
        Node<Pair<string, V>> pos = this.lst.GetFirst();

        while (pos != null)
        {
            if (pos.GetInfo().GetKey().Equals(key))
                return true;
            pos = pos.GetNext();
        }

        return false;
    }

    // הנחה: המפתח קיים במפה
	public V GetValue(string key)
	{
		Node<Pair<string,V>> pos = this.lst.GetFirst();
	
		while(!pos.GetInfo().GetKey().Equals(key))
			    pos = pos.GetNext();
		
        return pos.GetInfo().GetValue();
	}
	
  
	public void Insert(string key, V value)
	{
		Node<Pair<string,V>> pos = this.lst.GetFirst();
		Node<Pair<string,V>> prev = null;
		
		while(pos!=null && key.CompareTo(pos.GetInfo().GetKey())>0)
		{
			prev = pos;
			pos = pos.GetNext();
		}
		
		if(pos != null && key.Equals(pos.GetInfo().GetKey()))
			pos.GetInfo().SetValue(value);
		else 
		{
			this.lst.Insert(prev,new Pair<string,V>(key,value));
			this.numOfKeys++;
		}
	}

    // הנחה: המפתח קיים במפה
	public V remove(string key)
	{
		Node<Pair<string,V>> pos = this.lst.GetFirst();
		
		while(!pos.GetInfo().GetKey().Equals(key))
		    pos = pos.GetNext();

		pos = this.lst.Remove(pos);
		this.numOfKeys--;
		
        return pos.GetInfo().GetValue();
	}
	
   
	public string[] GetAllKeys()
	{
		int k = 0;
		Node<Pair<string,V>> pos = this.lst.GetFirst();
		string[] keys = new string[this.numOfKeys];
		
		while(pos != null)
		{
			keys[k] = pos.GetInfo().GetKey();
			k++;
			pos = pos.GetNext();
		}
		return keys;
	}	
	
    
	public override string ToString()
	{
		string str = "[";
		Node<Pair<string,V>> pos = this.lst.GetFirst();
		
		while(pos != null)
		{
			if(pos.GetNext() != null)
				str = str + pos.GetInfo().GetKey() + ":" + pos.GetInfo().GetValue().ToString() + ", ";
			else
				str = str + pos.GetInfo().GetKey() + ":" + pos.GetInfo().GetValue().ToString();
			pos = pos.GetNext();
		}
		str = str + "]";
		
		return str;
	}
}