using Unit4.CollectionsLib;

/// <summary>
///    1  11 -    1,      1  2
/// </summary>
/// <author>   ,   ,  ,  </author>
/// <version> 28.11.2007 </version>
public class Dictionary
{
	private Map<Map<int>> dicMap;
	
	public Dictionary()
	{
		this.dicMap = new Map<Map<int>>();
	}

	public void AddWord(string word, string translation)
	{	
        Map<int> transMap;

		if(this.dicMap.ContainsKey(word))
            transMap = this.dicMap.GetValue(word);
		else
			transMap = new Map<int>();
			
		transMap.Insert(translation, 0);
		this.dicMap.Insert(word, transMap);
	}
	
	public void DelWord(string word)
	{
        if(this.dicMap.ContainsKey(word))
		    this.dicMap.Remove(word);
	}

	public string[] GetAllWords()
	{
		return this.dicMap.GetAllKeys();
	}
		
	public string[] GetTranslations(string word) 
	{
        Map<int> transMap;
		string[] allTranslations;

        if (this.dicMap.ContainsKey(word))
        {
            transMap = this.dicMap.GetValue(word);
            allTranslations = transMap.GetAllKeys();
        }
        else
			allTranslations = new string[0];
			
		return allTranslations;
	}
		
	public override string ToString()
	{
		int i,j;
		string str = "";
		string[] allTrans;
		string[] allWords = this.GetAllWords();
		
		for (i = 0; i < allWords.Length; i++)
		{
			str = str + allWords[i] + ": ";
			allTrans = this.GetTranslations(allWords[i]);
			for (j = 0; j < allTrans.Length-1; j++)
				str = str + allTrans[j] + ",";
			str = str + allTrans[j] + "\n";
		}
		
		return str;
	}
	
	
	// =======================================================
	//      , 
	//    1  11 -    1
	public List<string> translatesTo(string translation)
	{
		List<string> wordsList = new List<string>();
		string[] allWords = this.dicMap.GetAllKeys();

		for (int i = 0; i < allWords.Length; i++)
		{
			Map<int> transMap = this.dicMap.GetValue(allWords[i]);
			
			if(transMap.ContainsKey(translation))
				wordsList.Insert(null,allWords[i]);
		}
		
		return wordsList;
	}
	
	
	//      , 
	//    1  11 -    2 
	public List<string> spellCheck(string sentence)
	{
        List<string> lst = new List<string>();
        string[] words = sentence.Split(' ');  //   

        for (int i = 0; i < words.Length; i++)
        {
            if (!this.dicMap.ContainsKey(words[i]))
                lst.Insert(null, words[i]);
        }

        return lst;
	}
}
